import gtk
import os, string, sys, time

from firstboot.config import *
from firstboot.constants import *
from firstboot.functions import *
from firstboot.module import *

import gettext
_ = lambda x: gettext.ldgettext("firstboot", x)
N_ = lambda x: x


class moduleClass(Module):
    def __init__(self):
        Module.__init__(self)
        self.priority = 401
        self.sidebarTitle = N_("CERN customization")
        self.title = N_("CERN customization")
        self.icon = "cern-workstation.png"

    

    def createScreen(self):
        self.vbox = gtk.VBox()


        internalVBox = gtk.VBox()
        internalVBox.set_border_width(10)
        internalVBox.set_spacing(5)

        label = gtk.Label(_("For CERN systems (or systems being installed on CERN site)\n"
                            "we provide a predefined setup (AFS/Kerberos/time servers etc)\n"
                            "customized to fulfill a specific set of requirements.\n"
                            "\n"
                            "You should select this default if your machine is at CERN\n" ))

        label.set_line_wrap(True)
        label.set_alignment(0.0, 1)
        label.set_size_request(500, -1)
            
        self.okButton = gtk.RadioButton(None, (_("_Yes, customize my system for CERN")))
        self.okButton.set_active(True)

        self.afsCheckButton = gtk.CheckButton(_("Start _AFS filesystem client on boot"))
        afsAlign = gtk.Alignment(0.2,0,0.2,0)
        afsAlign.add(self.afsCheckButton)
        self.afsCheckButton.set_active(True)

        self.initgdmButton = gtk.CheckButton(_("Disable _GNOME initial user creation"))
        initgdmAlign = gtk.Alignment(0.2,0,0.2,0)
        initgdmAlign.add(self.initgdmButton)
        self.initgdmButton.set_active(True)
        
        self.doupdateButton = gtk.RadioButton(None,(_("Enable automatic system _updates  ")))
        doupdAlign = gtk.Alignment(0.2,0,0.2,0)
        doupdAlign.add(self.doupdateButton)
        self.doupdateButton.set_active(True)
        
        self.checkupdButton = gtk.RadioButton(self.doupdateButton, (_("Enable automatic _check for updates")))
        checkupdAlign = gtk.Alignment(0.2,0,0.2,0)
        checkupdAlign.add(self.checkupdButton)

        self.noButton = gtk.RadioButton(self.okButton, (_("N_o, I will do setup myself")))

        self.extdoupdateButton = gtk.RadioButton(None,(_("Enable automatic system _updates  ")))
        doextupdAlign = gtk.Alignment(0.2,0,0.2,0)
        doextupdAlign.add(self.extdoupdateButton)
        self.extdoupdateButton.set_active(True)
        self.extdoupdateButton.set_sensitive(False)

        self.checkextButton = gtk.RadioButton(self.extdoupdateButton,_("Enable automatic _check for updates"))
        checkextAlign = gtk.Alignment(0.2,0,0.2,0)
        checkextAlign.add(self.checkextButton)
        self.checkextButton.set_active(False)
        self.checkextButton.set_sensitive(False) 

        label2 = gtk.Label(_("\n"))
	label2.set_line_wrap(True)
        label2.set_alignment(0.0, 1)
        label2.set_size_request(500, -1)

        internalVBox.pack_start(label, False, True)
        internalVBox.pack_start(self.okButton, False)
        internalVBox.pack_start(afsAlign, False, 10)
	internalVBox.pack_start(initgdmAlign, False, 10)
        internalVBox.pack_start(doupdAlign, False, 10)
        internalVBox.pack_start(checkupdAlign, False, 10)
        internalVBox.pack_start(self.noButton, False)
        internalVBox.pack_start(doextupdAlign, False, 10)
        internalVBox.pack_start(checkextAlign, False, 10)
        internalVBox.pack_start(label2, False, True)
        
        self.okButton.connect("clicked", self.okButtonClicked)
        self.noButton.connect("clicked", self.noButtonClicked)

        self.vbox.pack_start(internalVBox, True, 5)

        self.vbox.pack_start(label, False, True)
     
    def okButtonClicked (self, args):
        self.afsCheckButton.set_sensitive(self.okButton.get_active())
        self.initgdmButton.set_sensitive(self.okButton.get_active())
        self.doupdateButton.set_sensitive(self.okButton.get_active())
        self.checkupdButton.set_sensitive(self.okButton.get_active())

    def noButtonClicked (self, args):
        self.checkextButton.set_sensitive(self.noButton.get_active())
        self.extdoupdateButton.set_sensitive(self.noButton.get_active())
 
    def apply(self, interface, testing=False):

        (status,output) = self.checkStatusOutput("/bin/rm -f /etc/sysconfig/lcm-firstboot")
   
        if self.okButton.get_active() == True:
            (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_START=yes > /etc/sysconfig/lcm-firstboot")
            (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_COMPONENTS=1 >> /etc/sysconfig/lcm-firstboot")            
            if self.afsCheckButton.get_active() == True:
                (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_STARTAFS=yes >> /etc/sysconfig/lcm-firstboot")
            else:
                (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_STARTAFS=no >> /etc/sysconfig/lcm-firstboot")
            if self.checkupdButton.get_active() == True:
                (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_UPDATE=0 >> /etc/sysconfig/lcm-firstboot")
            if self.doupdateButton.get_active() == True:
                (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_UPDATE=1 >> /etc/sysconfig/lcm-firstboot")
            if self.initgdmButton.get_active() == True:
                (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_GDMINITUSER=0 >> /etc/sysconfig/lcm-firstboot")
 
	else:
             (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_START=yes > /etc/sysconfig/lcm-firstboot")
             (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_COMPONENTS=0 >> /etc/sysconfig/lcm-firstboot")
             (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_STARTAFS=no >> /etc/sysconfig/lcm-firstboot")
             if self.extdoupdateButton.get_active() == True:
                 (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_UPDATE=1 >> /etc/sysconfig/lcm-firstboot")
             if self.checkextButton.get_active() == True:
                 (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_UPDATE=0 >> /etc/sysconfig/lcm-firstboot") 
             (status,output) = self.checkStatusOutput("/bin/echo LCM_FIRSTBOOT_GDMINITUSER=1 >> /etc/sysconfig/lcm-firstboot")
		
        return RESULT_SUCCESS

    def checkStatusOutput (self, cmdline):
        "checking both status and output of the cmdline expression"
        from commands import getstatusoutput
        (status, output) = getstatusoutput(cmdline)
        return (status,output)

    def initializeUI(self):
        pass

